<?xml version="1.0" encoding="utf-8"?>
<!-- Copyright 1999-2017. Plesk International GmbH. All rights reserved. -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="xml" indent="yes"/>

  <xsl:param name="is-hg-mode"/>

  <xsl:template match="
    //domain[count(phosting/subdomains/subdomain) > 0]/properties/dns-zone/dnsrec[@type = 'A'] |
    //site[count(phosting/subdomains/subdomain) > 0]/properties/dns-zone/dnsrec[@type = 'A']">
    <xsl:variable name="owner" select="../../.."/>
    <xsl:variable name="rec" select="."/>

    <xsl:choose>
        <xsl:when test="$is-hg-mode = 'true'">
            <xsl:if test="count($owner/phosting/subdomains/subdomain[@name =
                substring-before($rec/@src, concat('.', $owner/@name, '.'))]) = 0 or /migration-dump/dump-info/os-description/@type = 'windows'">
              <xsl:copy>
                <xsl:apply-templates select="@*|node()" />
              </xsl:copy>
            </xsl:if>
        </xsl:when>
        <xsl:otherwise>
            <xsl:copy>
              <xsl:apply-templates select="@*|node()" />
            </xsl:copy>
        </xsl:otherwise>
    </xsl:choose>
    <!--Remove subdomain's A record from domain DNS zone-->
  </xsl:template>

  <xsl:template match="@*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()" />
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>
